using Godot;
using System;

public partial class Blocks : TabContainer
{
	[Signal] public delegate void BlockEditEventHandler(Block block);
	[Signal] public delegate void BlockPickEventHandler(Block block);

	[Export] public Control BlockContainer { get; set; }
	[Export] public Block   Block 		{ get; set; }
	public void _PickBlock()
	{
		EmitSignal(SignalName.BlockPick);
        if (GetViewport().GuiGetFocusOwner() is not ItemBox itemBox) return;
        Block = itemBox.GetActor<Block>();
	}
	public void _EditBlock()
	{
		EmitSignal(SignalName.BlockEdit);
	}
	public void _AddPressed()
	{	
		var itemBox = new ItemBox()
		{
			Type = ActorType.Block
		};
		itemBox.Pressed += _PickBlock;
		Block = itemBox.GetActor<Block>();
		BlockContainer?.AddChild(itemBox);
	}
	public void _RemovePressed()
	{
		if (Block != null) Block.QueueFree();
		else
		{
			if (BlockContainer != null)
			{
				if (BlockContainer.GetChildCount() > 0)
				{
					BlockContainer.RemoveChild(BlockContainer.GetChild(BlockContainer.GetChildCount()-1));
				}
			}
		}
	}
}
