

using System;
using Godot;

[GlobalClass]
public partial class Cursor2D : Sprite2D
{
    [Export] public Node2D Level { get; set; }
    public bool        CanPlace    { get; set; } = true;
    public PackedScene CurrentItem { get; set; }

    public override void _Process(double delta)
    {
        base._Process(delta);
        GlobalPosition = GetGlobalMousePosition();

        if (CurrentItem != null && CanPlace && Input.IsActionPressed("mb_left"))
        {
            var newItem = CurrentItem.Instantiate<Node2D>();
            if (newItem == null) return;
            newItem.GlobalPosition = GlobalPosition;
            Level.AddChild(newItem);
        }
    }
}