using Godot;
using System;

public enum ItemType
{
	Block
}

[GlobalClass, Tool]
public partial class ItemBox : Button
{
	Actor 		_actor;
	ActorType 	_type;
	Vector2I    _offset;

	public static readonly ButtonGroup DefaultButtonGroup = new ButtonGroup();

	[Export] public ActorType Type 
	{
		get => _type;
		set 
		{
			if (_type != value)
			{
				_type = value;
				_actor.QueueFree();
				_actor = _type switch
                {
                    ActorType.Block 	=> new Block(),
                    ActorType.Player 	=> null,
                    ActorType.Bgo 		=> null,
                    ActorType.Npc	 	=> null,
                    ActorType.Warp 		=> null,
                    ActorType.Liquid	=> null,
					_					=> null
                };
				_actor.Position = Offset;
            }
		}
	}
	[Export] public Vector2I  Offset 
	{
		get => _offset;
		set
		{
			if (_offset != value)
			{
				_offset  = value;
				if (_actor != null) _actor.Position = _offset;
			}
		}
	}


    public override void _Ready()
    {
        base._Ready();
		ButtonGroup = DefaultButtonGroup;
		ToggleMode  = true;
    }

	public T GetActor<T>() where T : Actor 
	{
		return _actor as T;
	}
}
